// Jumping Kangaroo
// Louise, Livia und Lara
// Datum: 27.03.23
// 2D - Projekt 2. Jahr

/*******************************************************************************************************************************************************************************************/

// Bildvariablen
PImage background; 
PImage background2;
PImage Erklärung;
PImage Button;
PImage Anleitung;
PImage kreuz;
PImage kangaroo; 
PImage Kaktus; 
PImage holz;

//andere Variablen
int phase = 1;            // 1: Startseite; 2: Spiel; 3: Erklärung; 4: Ende
float kaktusX = 0;        //x-Kaktus-Koordinate
float holzX = 800;        //x-Holz-Koordinate
int holzY = 370;          //y-Holz-Koordinate
int timer = 0;            // Spielzeit 
int kangarooX, kangarooY; // Kangaroo-Koordinate 
int jumpHeight;           // Höhe von Sprung
float a = 4;              // Geschwindigkeit Hindernisse
boolean jumping;          // true wenn Kangaroo springt
boolean collision;        // true wenn es collision gibt

//Soundimport
import processing.sound.*;
SoundFile file;  //Button
SoundFile back;  //Background
SoundFile over;  //Game over
SoundFile spiel; //Spiel
SoundFile jump;  //Sprung

/*********************************************************************************************************************************************************************************************/

void setup() {
  
  //Grundeigenschaften
  size(810, 485); //Spielgrösse
  textSize(40);   //Textgröße
  fill(255);      //Textfarbe weiß
  textAlign(CENTER);
  
  // Bilder einladen
  background = loadImage("Background.jpg");
  Erklärung = loadImage("Erklärung.png");
  Button = loadImage ("Button.png");
  Anleitung = loadImage ("Anleitung.png");
  kreuz = loadImage ("kreuz.png");
  background2 = loadImage("background2.jpg");
  kangaroo = loadImage("kangaroo.png");
  Kaktus = loadImage("Kaktus.png");
  holz = loadImage ("holz.png");
  
  // Laden eine Sounddatei aus dem Ordner und spielen sie ab
  file = new SoundFile(this, "button.wav");
  back = new SoundFile(this, "background.wav");
  over = new SoundFile(this, "over.wav"); 
  spiel = new SoundFile (this, "spiel.mp3");
  jump = new SoundFile (this, "jump.mp3");
  back.play(); // den Hintergrundsound abspielen 
  
  //kangaroo Eigenschaften
  kangarooX = 60;
  kangarooY = 290;
  jumping = false; 
}

/********************************************************************************************************************************************************************************************/

void keyPressed() {
  
  if (keyCode == 32 && !jumping && kangarooY == 290) { //das Känguru springt, wenn man auf die Leertaste klickt (32)
    jumping = true;
    jumpHeight = kangarooY - 150; // Höhe von Sprung
    jump.play(); //den Sprungton abspielen
  }
}
/*********************************************************************************************************************************************************************************************/

void draw() {
  
  // Bild anzeigen
  image(background, 0, 0); 
  
/**********************************************************************************************************************************************************************************************/  
  
  if(phase == 1)// Startseite 
  
  {
    fill(0); // Textfarbe schwarz 
    text("Jumping Kangaroo",405,100);  // Texte anzeigen
    image (Button, 305,315, 200, 200); // Bild anzeigen
    image(Erklärung, 700, 40, 50, 50); // Bild anzeigen
    fill(255); //Textfarbe weiß
    text("Spiel",405,430); // Texte anzeigen 
     
      if(mousePressed) // wenn Maus gedrückt
  { 
    file.play(0); // den Klang der Button abspielen   
    
      if(mouseX >= 305 && mouseX <= 490 && mouseY >= 315 && mouseY <= 515) //Spieltaste
      {
        phase = 2; //Spielphase
        back.stop(); //Hintergrundmusik gestoppt 
        spiel.play(); //Spielmusik beginnt 
      }
      
       else if(mouseX >= 700 && mouseX <= 750 && mouseY >= 40 && mouseY <= 90) //Anleitungtaste
      {
        phase = 3; // Anleitungphase 
      }
    }
  }  
     
/*************************************************************************************************************************************************************************************************/
  
  else if(phase == 2) // Spiel
  
  { 
    image(background2, 0,0); // Bild anzeigen 
    image (kreuz, 5,5, 25, 25); //Bild anzeigen 
    fill(0); // Textfarbe schwarz 
    text("Timer:", 525, 70); // Texte anzeigen
    text(timer, 620, 70); // Texte anzeigen
    image(kangaroo, kangarooX, kangarooY, 150, 150);// Bild anzeigen
    image(Kaktus, kaktusX, 366, 50, 50); // Bild anzeigen
    image(holz, holzX, 370, 50, 50); // Bild anzeigen
    
    kaktusX = kaktusX - a; // kaktusX = kaktusX - Geschwindigkeit Hindernisse => cactus bewegt sich immer schneller
    holzX = holzX - a;     // holzX = holzX - Geschwindigkeit Hindernisse => cactus bewegt sich immer schneller
     
    if (kaktusX < -485 ) { // Ausgang 
     kaktusX = width; // nach links gehen (width = = die äußerste rechte Position)
     a = a + 0.3; // Beschleunigung der Hindernisgeschwindigkeit 
    }

    if (holzX < -485 ) { // Ausgang 
     holzX = width; // ach links gehen (width = = die äußerste rechte Position)
     a = a + 0.3; // Beschleunigung der Hindernisgeschwindigkeit 
    }
    
    // wenn kangaroo springt (-> voidPressed)
   if (jumping) 
   {
   if (kangarooY > jumpHeight) { // wenn die Höhe des Kängurus kleiner ist als die Höhe des Sprungs 
    kangarooY -= 5; // Känguru steigt um 5 
    } 
   else {
    jumping = false; 
    }
  } 
  
  else {
   if (kangarooY < 290) { // wenn die Höhe des Kängurus grosser ist als an der Höhe, wenn er sich am Boden befindet 
    kangarooY += 5; //// Känguru sinkt um 5 
    }
  } 
  
  
  //gibt es ein Kollision ? mit Kaktus und Kangaroo
   if (kangarooX + 50>= kaktusX -40 && kangarooX + 10 <= kaktusX + 35 && kangarooY + 120 >= 366 && kangarooY <= 416) {
    collision = true;
}
  //gibt es ein Kollision ? mit Holz und Kangaroo
   if (kangarooX + 70 >= holzX -25 && kangarooX + 10<= holzX + 35 && kangarooY + 120 >= holzY && kangarooY <= holzY + 50) {
    collision = true;
}
  // Wenn es Kollision gibt:
   if (collision) {
    phase = 4; // Endephase 
    spiel.stop(); //Spielmusik stoppen 
    over.play(); //GameOver Musik spielen
    jump.stop();//Sprungmusik stoppen 
}
   //Timer
    if(frameCount % 4 == 0) { // ob framecount ohne Rest durch 4 teilbar ist 
     timer++; // steigt in einer Sekunde um 15 Mal (60/15 = 4)
    }
    
   // Kreuz, Quit
    if(mousePressed && mouseButton == LEFT) // wenn Maus gedrückt
    {
    if(mouseX >= 5 && mouseX <= 30 && mouseY >= 5 && mouseY <= 30) //Kreuztaste 
    {
      phase = 1; // Anleitungphase 
      back.play(); // Backgroundmusik spielen 
      spiel.stop(); //Spielmusik stoppen
    }
  }
  }

/******************************************************************************************************************************************************************************************/

  if(phase == 3) { // Anleitungphase 
    image(background, 0, 0); // Bild anzeigen
    image(Anleitung, 200, 50, 400, 400); // Bild anzeigen
    
    
    if(mousePressed && mouseButton == LEFT) // wenn Maus gedrückt
    {
    if(mouseX >= 550 && mouseX <= 600 && mouseY >= 50 && mouseY <= 100) // Anleitungtaste 
    {
      phase = 1; // Startseite  
      file.stop(); // Buttonsound stoppen 
    }
    }
  }

/********************************************************************************************************************************************************************************************/

   if(phase == 4){ // Endephase 
   
     image(background, 0, 0); // Bild anzeigen 
     fill(255,0,0); // Textfarbe Rot 
     text("GAME OVER",405,100); // Text anzeigen 
     image (Button, 130,315, 200, 200); // Bild anzeigen 
     image (Button, 480,315, 200, 200); // Bild anzeigen 
     fill(255); // Textfarbe weiss
     text("Replay",230,430); // Text anzeigen 
     text("Home",580,430); // text anzeigen 
     fill(0); // Textfarbe schwarz 
     text("Timer:",360,200); // Text anzeigen 
     text(timer, 480,200); // Text anzeigen 
    
 
    if(mousePressed && mouseButton == LEFT) // wenn Maus gedrückt
    {
      if(mouseX >= 130 && mouseX <= 330 && mouseY >= 315 && mouseY <= 515) // Replay Taste
    {
        phase = 2; // Spielphase
        over.stop(); // GameOver Sound stoppen
        spiel.play(); // Spielmusik beginnt 
        file.play(); // Buttonsound beginnt 
        
     // Neuinitialisierung von Eigenschaften 
    kaktusX = 0; 
    holzX = 800;
    holzY = 370;
    timer = 0;
    kangarooX = 60;
    kangarooY = 290;
    jumpHeight = 363; 
    jumping = false;
    collision = false;
    a = 4;
    }
   
       else if(mouseX >= 480 && mouseX <= 680 && mouseY >= 315 && mouseY <= 515) // Home Taste
      {
        phase = 1;
        over.stop();
        back.play();
        
     // Neuinitialisierung von Eigenschaften 
    kaktusX = 0;
    holzX = 800;
    holzY = 370;
    timer = 0;
    kangarooX = 60;
    kangarooY = 290;
    jumpHeight = 363;
    a = 4;
    jumping = false;
    collision = false;
      }
    }
  }
}
